/* -*- opencl -*- */
/*
 * Copyright 2015 <Arnaud Durand>.
 *
 * This is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3, or (at your option)
 * any later version.
 *
 * This software is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this software; see the file COPYING.  If not, write to
 * the Free Software Foundation, Inc., 51 Franklin Street,
 * Boston, MA 02110-1301, USA.
 */

__kernel void fir_kernel(__global float2 *A, __constant float *B, __global float2 *C, int delay_len)
{
    //Get the index of the work-item \n"
    int filter = get_global_id(0);
    int delay = get_global_id(1);

    float2 dotProduct = (float2)( 0, 0 );

    __global float2 *delay0 = A + (8192+delay_len) * filter + delay;
    __constant float *w = B + delay_len * filter;

    for(int i=0; i<delay_len; i++){
      dotProduct = /*fma*/mad(delay0[i], w[i], dotProduct);
    }

    int nfilts = get_global_size (0);
    C[nfilts*delay + filter] = dotProduct;

}
